// Function prototypes for core system functions in system.c
#ifndef __SYSTEM_H
#define __SYSTEM_H

#include "stdint.h"

void cpu_init();
void delay_ms(uint32_t delay);
uint32_t rand();
uint32_t *framebuffer_start();
void lcd_init();
void set_pixel(uint32_t x, uint32_t y, uint8_t color);
void clear_lcd();
void draw_char(uint32_t x, uint32_t y, uint8_t c, uint8_t color);
void draw_string(const uint8_t* s, uint32_t x, uint32_t y, uint8_t color);

const uint8_t color_lookup[]=
    {
        0xff,          /* white */
        0xe0,          /* red */
        0x1c,          /* green */
        0x03,          /* blue */
        0xe0 | 0x1c,   /* red + green */
        0x1c | 0x03,   /* green + blue */
        0xe0 | 0x03,   /* red + blue */
        0,             /* black */
    };

#endif
